import { PushProcessOptions } from '../../index';
import { TypeOfCommit } from '../commit-data';
import { BaseCommandLineFeature } from './base-command-line-feature';
import { BaseProject } from './base-project';
import type { BaseProjectResolver } from './base-project-resolver';
export declare class BaseGlobalCommandLine<PARAMS = any, PROJECT extends BaseProject<any, any> = BaseProject<any, any>, PROJECT_RESOLVER extends BaseProjectResolver<PROJECT> = BaseProjectResolver<PROJECT>> extends BaseCommandLineFeature<PARAMS, PROJECT, PROJECT_RESOLVER> {
    _(): void;
    /**
     * @returns true is sudo was used to restart the process
     */
    protected _runAsSudoIfNotElevated({ globalCommandName, }: {
        globalCommandName?: string;
    }): Promise<boolean>;
    /**
     * TODO return argument not need for now
     */
    cwdIsProject(options?: {
        requireProjectWithGitRoot?: boolean;
    }): Promise<boolean>;
    hosts(): Promise<void>;
    countCommits(): void;
    removeSubmodules(): void;
    removeSubmodule(): void;
    setEditor(): Promise<void>;
    upapi(): Promise<void>;
    upapiAll(): Promise<void>;
    apiup(): Promise<void>;
    apiupall(): Promise<void>;
    apiUpdate(): Promise<void>;
    apiUpdateAll(): Promise<void>;
    upapiforce(): Promise<void>;
    apiupforce(): Promise<void>;
    apiUpdateForce(): Promise<void>;
    cu(): Promise<void>;
    choreUpdate(): Promise<void>;
    colorvscode(): void;
    /**
     * Generate or update .vscode/settings.json file color settings
     */
    settingsVscode(): void;
    refreshVscodeColors(): void;
    protected _regenerateVscodeSettingsColors(overideBottomColor?: string): void;
    private updateProject;
    forceUpdate(): Promise<void>;
    /**
     * alias for forceupdate
     */
    forceup(): Promise<void>;
    update(): Promise<void>;
    /**
     * alias for update
     */
    up(): Promise<void>;
    upForce(): Promise<void>;
    /**
     * alias for update
     */
    pu(): Promise<void>;
    docsUpdate(): Promise<void>;
    /**
     * alias for docsUpdate
     */
    docsUp(): Promise<void>;
    upDocs(): Promise<void>;
    deepUpdate(): Promise<void>;
    /**
     * alias for deepupdate
     */
    deepUp(): Promise<void>;
    updateAll(): Promise<void>;
    /**
     * alias for updateAll
     */
    upAll(): Promise<void>;
    deepUpdateForce(): Promise<void>;
    /**
     * alias for deepUpdateForce
     */
    deepUpForce(): Promise<void>;
    develop(): Promise<void>;
    dev(): Promise<void>;
    repul(): Promise<void>;
    repull(): Promise<void>;
    pul(): Promise<void>;
    pull(): Promise<void>;
    pullAll(): Promise<void>;
    pp(): Promise<void>;
    fetch(): Promise<void>;
    reset(): Promise<void>;
    resetAll(): Promise<void>;
    resetDeep(): Promise<void>;
    private resetProject;
    soft(): Promise<void>;
    rebase(): Promise<void>;
    /**
     * stash only staged files
     */
    stash(): Promise<void>;
    /**
     * stash all files
     */
    stashAll(): Promise<void>;
    /**
     * push force to all origins
     */
    pushAllForce(): Promise<void>;
    pAllForce(): Promise<void>;
    pAllf(): Promise<void>;
    pAll(): Promise<void>;
    /**
     * push to all origins
     */
    pushAll(force?: boolean): Promise<void>;
    forcePush(): Promise<void>;
    pushForce(): Promise<void>;
    /**
     * Commit and push this for single repo
     */
    commit(options?: {
        force?: boolean;
        typeofCommit?: TypeOfCommit;
        origin?: string;
        commitMessageRequired?: boolean;
        noExit?: boolean;
    }): Promise<void>;
    _preventPushPullFromNotCorrectBranch(): Promise<void>;
    qPush(): Promise<void>;
    quickPush(): Promise<void>;
    repushauto(): Promise<void>;
    rePush(skipQuesion?: boolean): Promise<void>;
    push(options?: PushProcessOptions): Promise<void>;
    melt(): Promise<void>;
    meltUp(): Promise<void>;
    meltAll(): Promise<void>;
    private __meltCommitsFunc;
    private meltUpdateCommits;
    pf(): Promise<void>;
    pRel(): Promise<void>;
    pRelease(): Promise<void>;
    pushRelease(): Promise<void>;
    mPush(): Promise<void>;
    fmPush(): Promise<void>;
    mfPush(): Promise<void>;
    mforcePush(): Promise<void>;
    meltforcePush(): Promise<void>;
    forceMeltPush(): Promise<void>;
    meltPush(force?: boolean): Promise<void>;
    pushFeature(): Promise<void>;
    pushFix(): Promise<void>;
    pfix(): void;
    pushChore(): Promise<void>;
    pc(): Promise<void>;
    pushRefactor(): Promise<void>;
    pushref(): Promise<void>;
    pref(): Promise<void>;
    pushStyle(): Promise<void>;
    pstyl(): Promise<void>;
    pstyle(): Promise<void>;
    pushDocs(): Promise<void>;
    pd(): Promise<void>;
    pdocs(): Promise<void>;
    pushTest(): Promise<void>;
    pTest(): Promise<void>;
    pTests(): Promise<void>;
    pushPerf(): Promise<void>;
    pushCi(): Promise<void>;
    branch(): Promise<void>;
    pushBuild(): Promise<void>;
    SET_ORIGIN(): Promise<void>;
    $COPY_AND_RENAME(): Promise<void>;
    RENAME_ORIGIN(): Promise<void>;
    LAST_TAG_HASH(): Promise<void>;
    LAST_TAG(): Promise<void>;
    CHECK_TAG_EXISTS(): void;
    /**
     * TODO move somewhere
     */
    lint(): Promise<void>;
    /**
     * TODO move somewhere
     */
    lintStaged(): Promise<void>;
    /**
     * TODO move somewhere
     */
    version(): Promise<void>;
    /**
     * TODO move somewhere
     */
    init(): Promise<void>;
    /**
     * init parent and first level children
     */
    initAll(): Promise<void>;
    /**
     * init parent and first level children
     */
    structAll(): Promise<void>;
    /**
     * TODO move somewhere
     */
    struct(): Promise<void>;
    /**
     * TODO move somewhere
     */
    info(): Promise<void>;
    modified(): Promise<void>;
    refresh(): Promise<void>;
    changes(): Promise<void>;
    allTags(): Promise<void>;
    removeTag(): Promise<void>;
    BRANCH_NAME(): void;
    REMOTES(): void;
    SET_REMOTE_SSH(): Promise<void>;
    SET_REMOTE_http(): Promise<void>;
    SET_REMOTE_https(): Promise<void>;
    protected _resolveChildFromArg(): void;
    origin(): void;
    remote(): void;
    originHttp(): void;
    originHttps(): void;
    originssh(): void;
    origins(): void;
    gitConfig(): Promise<void>;
    LAST_COMMIT_HASH(): void;
    COMMIT_MESSAGE_BY_HASH(): Promise<void>;
    LAST_5_COMMITS(): Promise<void>;
    updateDepsFrom(): Promise<void>;
    isSupportedTaonTerminal(): void;
    isRunningInWindowsCmd(): void;
    isRunningInWindowsPowerShell(): void;
    INSTALL_PROJECT_EXTENSIONS(): Promise<void>;
    INSTALL_PROJECT_EXT(): Promise<void>;
    INS_PROJ_EXT(): Promise<void>;
    INSTALL_PROJ_EXT(): Promise<void>;
    projdb(): Promise<void>;
    private __filterBranchesByPattern;
    private __selectBranch;
    clone(): Promise<void>;
    ghSave(): Promise<void>;
    ghRestore(): Promise<void>;
    ports(): Promise<void>;
    /**
     * tnp startCliServicePortsWorker --restart
     */
    startCliServicePortsWorker(): Promise<void>;
    waitForUserAnyKey(): Promise<void>;
    pauseTerminal(): void;
    sleepTerminal(): void;
    ghPagesInit(): Promise<void>;
    isPortInUse(): Promise<void>;
    procInfo(): void;
    processInfo(): void;
    lastGitTag(): void;
    checkPort(): Promise<void>;
    checkPorts(): Promise<void>;
    symlink(): void;
    isSymlinkFileExitedOrUnexisted(): void;
    removeSymlinksDryRun(): void;
    selectJava(): Promise<void>;
    selectTomcat(): Promise<void>;
    LN(): void;
    copy(): void;
    killAllCode(): void;
    killAllCodium(): void;
    killAllCursor(): void;
    killAllTheia(): void;
    killAllCodeOSS(): void;
    editor(): Promise<void>;
    editorSettings(): Promise<void>;
    simulateDomain(): Promise<void>;
    preview(): Promise<void>;
    /**
     * read huge file and display only lines with specyfic words
     */
    shorten(): Promise<void>;
    dumpPackagesVersions(): void;
    zip(): Promise<void>;
    unzip(): Promise<void>;
    startTransmission(): Promise<void>;
    _removeTransmission(): Promise<void>;
    backupBranch(): Promise<void>;
    bb(): Promise<void>;
    countCodeLines(): Promise<void>;
    countCode(): Promise<void>;
    countLines(): Promise<void>;
    isNodeVersionOk(): void;
    pwd(): void;
    more(): Promise<void>;
    less(): Promise<void>;
    /**
     *  npm install --global bin-version-check-cli
     *  npm i -g yt-dlp
     *  choco install ffmpeg
     */
    MP3(): void;
    MP4(args: any): void;
    gif(): void;
    killZs(): void;
    startZs(): void;
    zsKill(): void;
    zsStart(): void;
    startZscaller(): void;
    killZscaller(): void;
    hasCommand(): Promise<void>;
    hasCommandSync(): void;
    publicIpAddress(): Promise<void>;
    publicIp(): Promise<void>;
    localIps(): Promise<void>;
    isOnline(): Promise<void>;
    configureBash(): Promise<void>;
    configureShell(): Promise<void>;
    confBash(): void;
    confShell(): void;
    gitResetAll(): void;
    isElevated(): Promise<void>;
    sudoCheck(): Promise<void>;
    pythonModuleExists(): Promise<void>;
    splitNamespaces(): void;
    splitNamespace(): void;
    normalizeBrokenLines(): void;
    stripTsTypesIntoJs(): Promise<void>;
}
